# -*- encoding: utf-8 -*-
import re
from HTMLParser import HTMLParser
from BeautifulSoup import BeautifulSoup

class LBParser(object):
    """LBParser extract text from html, htm, xml files.
       based in http://stackoverflow.com/a/1983219/564709
    """
    def __init__(self, html):
        super(LBParser, self).__init__()
        self.soup = BeautifulSoup(html)
        self.texts = self.soup.findAll(text=True)

    def get_text(self):
        """Main method.
           @return string
        """
        return self.unercape()

    def visible(self, element):
        """ Removes unnecessary text.
            @return bool 
        """
        if element.parent.name in ['style', 'script', '[document]', 'head', 'title']:
            return False
        elif re.match('<!--.*-->', str(element)):
            return False
        return True
        
    def filter_text(self):
        """ Alias visible method.
            @return list
        """
        return filter(self.visible, self.texts)

    def unercape(self):
        """parser.unescape('&atilde;')
           http://stackoverflow.com/questions/17341601/\
           convert-string-from-xmlcharrefreplace-back-to-utf-8
           @visible_texts list
           @return str
        """
        parser = HTMLParser()
        return parser.unescape( ' '.join(self.filter_text() ) )