import logging
import os
import config
import subprocess


def get_config_env():
    """
        Show configurations
    """
    logger.info("###### REPORT TESSERACT CONFIG STATUS #######")
    environ = dict(os.environ)
    try:
        cmd = [config.TESSERACT_CMD, '--list-langs']
        tesseract = subprocess.Popen(cmd,
                                     stdout=subprocess.PIPE,
                                     stderr=subprocess.PIPE,
                                     stdin=subprocess.PIPE)
    except OSError as e:
        logger.error("OSError in command %s. Error: %s" % (str(cmd), e))

    tesseract_output, tesseract_error = tesseract.communicate()
    logger.info("lang list:\n %s \n %s" % (tesseract_output, tesseract_error))
    logger.info("Check environ PATH: ")

    logger.info("Using TESSDATA_PREFIX %s" % environ.get("TESSDATA_PREFIX", "Not Found"))
    if environ.get("TESSDATA_PREFIX"):
        try:
            logger.info("Directory lang: %s" % str(os.listdir(environ.get("TESSDATA_PREFIX"))))
        except OSError as e:
            logger.error("OSError in listdir. Error: %s" % e)
    else:
        try:
            logger.info("Directory lang: %s" % str(os.listdir(config.TESSDATA_PREFIX)))
        except OSError as e:
            logger.error("OSError in listdir config. Error: %s" % e)


logger = logging.getLogger("LBConverter")
