#!/usr/bin/python
# -*- coding: utf-8 -*-

from setuptools import setup, find_packages
import os

class packageInstaller:
    """ Classe utilizada para instalar um pacote "package", instalando-o na 
    pasta "directory", de acordo com a estrutura proposta.
    """

    def __init__(self, package, directory, bin_check):
        self.package = package
        self.directory = os.getcwd() + directory
        self.bin_check = bin_check

    def install(self):
        cur_dir = os.getcwd()
        print('starting the module installation', cur_dir)
        os.chdir(cur_dir + "/lib/"+ self.package)
        os.system("autoreconf -i")
        os.system("./configure --prefix=" + self.directory)
        os.system("make && make install")
        os.chdir(cur_dir)

        # NOTE: Para checar se a instalação foi bem sucedida, verifica se o 
        # binario existe em "bin_check".
        try:
            open(self.directory+"/bin/"+self.bin_check)
        except:
            print "ERROR - Package " + self.package + " not installed succesfully...\nPlease check its dependencies or other installation errors!"

    def custom_install(self):
        """ Caso mude o diretório padrão de instalação, alterar o arquivo em 
        lib/antiword.h colocar o valor do caminho a ser utilizado na variável 
        GLOBAL_ANTIWORD_DIR.

        TODO: Conseguir uma forma mais genérica ou adicionar um arquivo de 
        configuração ao arquivo antiword.h
        """

        cur_dir = os.getcwd()
        install_dir = self.directory + '/bin'
        resources_dir = self.directory + '/resources'
        params = 'GLOBAL_INSTALL_DIR=%s GLOBAL_RESOURCES_DIR=%s' % (install_dir, resources_dir)
        os.chdir(cur_dir + "/lib/"+ self.package)
        print params
        # Altera o arquivo antiword.h na linha 227
        os.system("""sed -i '227s/.*/#define GLOBAL_ANTIWORD_DIR    "%s"/' antiword.h""" % resources_dir.replace("/", "\/"))
        os.system("make all %s" % params)
        os.system("make global_install %s" % params)
        os.system("make clean")
        os.chdir(cur_dir)

        try:
            open(self.directory+"/bin/"+self.bin_check)
        except:
            print "ERROR - Package " + self.package + " not installed succesfully...\nPlease check its dependencies or other installation errors!"

unrtf = packageInstaller("unrtf-0.21.9","/bin/unrtf","unrtf")
unrtf.install()
xpdf = packageInstaller("xpdf-3.04","/bin/xpdf","pdftotext")
xpdf.install()
antiword = packageInstaller('antiword-0.37','/bin/antiword','antiword')
antiword.custom_install()

requires = [
    'ConfigParser == 3.3.0r2',
    'requests == 2.3.0',
    'ordereddict == 1.1',
    'pdfminer == 20140328',
    'BeautifulSoup',
    'xlrd == 0.9.4',
    'pyramid == 1.6b2',
    'pyramid_chameleon == 0.3',
    'waitress == 0.8.10'
    ]

'''
NOTE: Para versionamento usar "MAJOR.MINOR.REVISION.BUILDNUMBER"! By Questor
http://programmers.stackexchange.com/questions/24987/what-exactly-is-the-build-number-in-major-minor-buildnumber-revision
'''
setup(
    name = "LBConverter",
    version = "0.1.2.0",
    author = "Lightbase",
    author_email = "",
    url = "https://pypi.python.org/pypi/LBConverter",
    description = "Daemon Converter for the neo-lightbase service",
    license = "GPLv2",
    keywords = "Converter extractor lightbase daemon",
    install_requires=requires,
    tests_require=requires,
    test_suite="lbcapi",
    entry_points="""\
    [paste.app_factory]
    main = lbcapi:main
    """,
    packages=find_packages(),
    include_package_data=True,
    zip_safe=False,
    classifiers=[
        "Development Status :: 2 - Pre-Alpha",
        "Environment :: No Input/Output (Daemon)",
        "License :: OSI Approved :: GNU General Public License v2 (GPLv2)",
        "Natural Language :: Portuguese (Brazilian)",
        "Programming Language :: Python :: 2.7",
        "Topic :: Database :: Database Engines/Servers",
        "Topic :: Internet :: WWW/HTTP",
        "Topic :: Internet :: WWW/HTTP :: WSGI :: Application",
        "Framework :: Pyramid"
    ]
)
