#!/bin/bash

# Instalação das dependências do LBC - LBConverter no python2.X!

. ./ez_i.bash

EZ_I_SKIP_ON_V=$1
if [ -z "$EZ_I_SKIP_ON_V" ] ; then
    EZ_I_SKIP_ON_V=0
fi

BASE_INST_DIR_V=$2
# > -----------------------------------------
# Informar o diretório base da instalação!

if [ -z "$BASE_INST_DIR_V" ] ; then
    f_open_section
    BASE_INST_DIR_V="/usr/local/lb"

    QUESTION_F="Enter the installation directory. 
Use empty for \"$BASE_INST_DIR_V\"!"

    f_get_usr_input "$QUESTION_F" 1
    QUESTION_F=""
    if [ -n "$GET_USR_INPUT_R" ] ; then
        BASE_INST_DIR_V="$GET_USR_INPUT_R/lb"
    fi
    f_close_section
fi

# < -----------------------------------------

PYTHON_2_X=$3
if [ -z "$PYTHON_2_X" ] ; then
    PYTHON_2_X="2.7"
fi

VE_2_X=$4
if [ -z "$VE_2_X" ] ; then
    VE_2_X="lbc_ve27"
fi

f_open_section

TITLE_F="Install LBC - LBConverter dependencies for python$PYTHON_2_X?"

f_yes_no "$TITLE_F"
TITLE_F=""

if [ ${EZ_I_SKIP_ON_V} -eq 1 ] || [ ${YES_NO_R} -eq 1 ] ; then

    cd "$SCRIPTDIR_V"
    cd ./py-packs-LBConverter

    tar -zxvf ./ordereddict-1.1.tar.gz
    cd ./ordereddict-1.1
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./ordereddict-1.1

    tar -zxvf ./configparser-3.3.0r2.tar.gz
    cd ./configparser-3.3.0r2
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./configparser-3.3.0r2

    tar -zxvf ./pdfminer-20140328.tar.gz
    cd ./pdfminer-20140328
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./pdfminer-20140328

    tar -zxvf ./requests-2.3.0.tar.gz
    cd ./requests-2.3.0
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./requests-2.3.0

    tar -zxvf ./PasteDeploy-1.5.2.tar.gz
    cd ./PasteDeploy-1.5.2
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./PasteDeploy-1.5.2

    tar -zxvf ./venusian-1.0.tar.gz
    cd ./venusian-1.0
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./venusian-1.0

    tar -zxvf ./translationstring-1.3.tar.gz
    cd ./translationstring-1.3
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./translationstring-1.3

    tar -zxvf ./zope.deprecation-4.1.2.tar.gz
    cd ./zope.deprecation-4.1.2
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./zope.deprecation-4.1.2

    tar -zxvf ./zope.interface-4.1.3.tar.gz
    cd ./zope.interface-4.1.3
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./zope.interface-4.1.3

    tar -zxvf ./repoze.lru-0.6.tar.gz
    cd ./repoze.lru-0.6
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./repoze.lru-0.6

    tar -zxvf ./WebOb-1.5.1.tar.gz
    cd ./WebOb-1.5.1
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./WebOb-1.5.1

    tar -zxvf ./pyramid-1.6b2.tar.gz
    cd ./pyramid-1.6b2
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./pyramid-1.6b2

    tar -zxvf ./pbr-0.10.0.tar.gz
    cd ./pbr-0.10.0
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./pbr-0.10.0

    tar -zxvf ./linecache2-1.0.0.tar.gz
    cd ./linecache2-1.0.0
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./linecache2-1.0.0

    tar -zxvf ./traceback2-1.4.0.tar.gz
    cd ./traceback2-1.4.0
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./traceback2-1.4.0

    tar -zxvf ./six-1.7.2.tar.gz
    cd ./six-1.7.2
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./six-1.7.2

    tar -zxvf ./argparse-1.3.0.tar.gz
    cd ./argparse-1.3.0
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./argparse-1.3.0

    tar -zxvf ./unittest2-1.0.1.tar.gz
    cd ./unittest2-1.0.1
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./unittest2-1.0.1

    tar -zxvf ./Chameleon-2.24.tar.gz
    cd ./Chameleon-2.24
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./Chameleon-2.24

    tar -zxvf ./pyramid_chameleon-0.3.tar.gz
    cd ./pyramid_chameleon-0.3
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./pyramid_chameleon-0.3

    tar -zxvf ./waitress-0.8.10.tar.gz
    cd ./waitress-0.8.10
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./waitress-0.8.10

    tar -zxvf ./xlrd-0.9.4.tar.gz
    cd ./xlrd-0.9.4
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./xlrd-0.9.4

    tar -zxvf ./BeautifulSoup-3.2.1.tar.gz
    cd ./BeautifulSoup-3.2.1
    eval "$BASE_INST_DIR_V/$VE_2_X/bin/python$PYTHON_2_X setup.py install"
    cd ..
    rm -rf ./BeautifulSoup-3.2.1

fi
